# RetainedGraphicsExample.py

from AnimationWithRetainedGraphics import *

###########################################
# RetainedGraphicsExample class
###########################################

class RetainedGraphicsExample(AnimationWithRetainedGraphics):
    def mousePressed(self, event): self.randomizeColors()
    def keyPressed(self, event): self.randomizeColors()
    
    def randomizeColors(self):
        self.rect.line = Color.randomColor()
        self.oval.fill = Color.randomColor()
        self.circle.fill = Color.randomColor()

    def timerFired(self):
        self.rect.left += 10
        if (self.rect.left > self.width): self.rect.left = -150
        self.rect.right = self.rect.left + 150
        
    def init(self):
        print "Click to randomize colors"
        self.rect = self.createRectangle(50, 50, 200, 150)
        self.oval = self.createOval(75, 50, 225, 150)
        self.rect.lineWidth = 2
        self.rect.line = Color(255, 165, 0)   # orange
        self.oval.fill = Color(137, 207, 240) # baby blue
        self.circle = self.createCircle(150, 100, 40) # (cx, cy, radius)
        self.timerFiredDelay = 1 

app = RetainedGraphicsExample()
app.run()